"""autogenerated by genpy from pr2_create_object_model/ModelObjectInHandGoal.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import geometry_msgs.msg
import std_msgs.msg

class ModelObjectInHandGoal(genpy.Message):
  _md5sum = "dbd0a8f991b14588bbd523abc948c0b6"
  _type = "pr2_create_object_model/ModelObjectInHandGoal"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======
# which arm to use
string arm_name

# the relative motion in which to move the gripper to get it clear of objects 
#(if left unfilled, will not move)
geometry_msgs/Vector3Stamped clear_move

# the pose to go to for rotating (if left unfilled, will not go)
geometry_msgs/PoseStamped rotate_pose

# whether to rotate the object at rotate_pose to build up the model
uint8 rotate_object

# whether to add the object to the collision map 
uint8 add_to_collision_map

# whether to keep the object level while rotating
uint8 keep_level


================================================================================
MSG: geometry_msgs/Vector3Stamped
# This represents a Vector3 with reference coordinate frame and timestamp
Header header
Vector3 vector

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 

float64 x
float64 y
float64 z
================================================================================
MSG: geometry_msgs/PoseStamped
# A Pose with reference coordinate frame and timestamp
Header header
Pose pose

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

"""
  __slots__ = ['arm_name','clear_move','rotate_pose','rotate_object','add_to_collision_map','keep_level']
  _slot_types = ['string','geometry_msgs/Vector3Stamped','geometry_msgs/PoseStamped','uint8','uint8','uint8']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       arm_name,clear_move,rotate_pose,rotate_object,add_to_collision_map,keep_level

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(ModelObjectInHandGoal, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.arm_name is None:
        self.arm_name = ''
      if self.clear_move is None:
        self.clear_move = geometry_msgs.msg.Vector3Stamped()
      if self.rotate_pose is None:
        self.rotate_pose = geometry_msgs.msg.PoseStamped()
      if self.rotate_object is None:
        self.rotate_object = 0
      if self.add_to_collision_map is None:
        self.add_to_collision_map = 0
      if self.keep_level is None:
        self.keep_level = 0
    else:
      self.arm_name = ''
      self.clear_move = geometry_msgs.msg.Vector3Stamped()
      self.rotate_pose = geometry_msgs.msg.PoseStamped()
      self.rotate_object = 0
      self.add_to_collision_map = 0
      self.keep_level = 0

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self.arm_name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_3I.pack(_x.clear_move.header.seq, _x.clear_move.header.stamp.secs, _x.clear_move.header.stamp.nsecs))
      _x = self.clear_move.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_3d3I.pack(_x.clear_move.vector.x, _x.clear_move.vector.y, _x.clear_move.vector.z, _x.rotate_pose.header.seq, _x.rotate_pose.header.stamp.secs, _x.rotate_pose.header.stamp.nsecs))
      _x = self.rotate_pose.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_7d3B.pack(_x.rotate_pose.pose.position.x, _x.rotate_pose.pose.position.y, _x.rotate_pose.pose.position.z, _x.rotate_pose.pose.orientation.x, _x.rotate_pose.pose.orientation.y, _x.rotate_pose.pose.orientation.z, _x.rotate_pose.pose.orientation.w, _x.rotate_object, _x.add_to_collision_map, _x.keep_level))
    except struct.error as se: self._check_types(se)
    except TypeError as te: self._check_types(te)

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.clear_move is None:
        self.clear_move = geometry_msgs.msg.Vector3Stamped()
      if self.rotate_pose is None:
        self.rotate_pose = geometry_msgs.msg.PoseStamped()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.arm_name = str[start:end].decode('utf-8')
      else:
        self.arm_name = str[start:end]
      _x = self
      start = end
      end += 12
      (_x.clear_move.header.seq, _x.clear_move.header.stamp.secs, _x.clear_move.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.clear_move.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.clear_move.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 36
      (_x.clear_move.vector.x, _x.clear_move.vector.y, _x.clear_move.vector.z, _x.rotate_pose.header.seq, _x.rotate_pose.header.stamp.secs, _x.rotate_pose.header.stamp.nsecs,) = _struct_3d3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.rotate_pose.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.rotate_pose.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 59
      (_x.rotate_pose.pose.position.x, _x.rotate_pose.pose.position.y, _x.rotate_pose.pose.position.z, _x.rotate_pose.pose.orientation.x, _x.rotate_pose.pose.orientation.y, _x.rotate_pose.pose.orientation.z, _x.rotate_pose.pose.orientation.w, _x.rotate_object, _x.add_to_collision_map, _x.keep_level,) = _struct_7d3B.unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self.arm_name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_3I.pack(_x.clear_move.header.seq, _x.clear_move.header.stamp.secs, _x.clear_move.header.stamp.nsecs))
      _x = self.clear_move.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_3d3I.pack(_x.clear_move.vector.x, _x.clear_move.vector.y, _x.clear_move.vector.z, _x.rotate_pose.header.seq, _x.rotate_pose.header.stamp.secs, _x.rotate_pose.header.stamp.nsecs))
      _x = self.rotate_pose.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_7d3B.pack(_x.rotate_pose.pose.position.x, _x.rotate_pose.pose.position.y, _x.rotate_pose.pose.position.z, _x.rotate_pose.pose.orientation.x, _x.rotate_pose.pose.orientation.y, _x.rotate_pose.pose.orientation.z, _x.rotate_pose.pose.orientation.w, _x.rotate_object, _x.add_to_collision_map, _x.keep_level))
    except struct.error as se: self._check_types(se)
    except TypeError as te: self._check_types(te)

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.clear_move is None:
        self.clear_move = geometry_msgs.msg.Vector3Stamped()
      if self.rotate_pose is None:
        self.rotate_pose = geometry_msgs.msg.PoseStamped()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.arm_name = str[start:end].decode('utf-8')
      else:
        self.arm_name = str[start:end]
      _x = self
      start = end
      end += 12
      (_x.clear_move.header.seq, _x.clear_move.header.stamp.secs, _x.clear_move.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.clear_move.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.clear_move.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 36
      (_x.clear_move.vector.x, _x.clear_move.vector.y, _x.clear_move.vector.z, _x.rotate_pose.header.seq, _x.rotate_pose.header.stamp.secs, _x.rotate_pose.header.stamp.nsecs,) = _struct_3d3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.rotate_pose.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.rotate_pose.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 59
      (_x.rotate_pose.pose.position.x, _x.rotate_pose.pose.position.y, _x.rotate_pose.pose.position.z, _x.rotate_pose.pose.orientation.x, _x.rotate_pose.pose.orientation.y, _x.rotate_pose.pose.orientation.z, _x.rotate_pose.pose.orientation.w, _x.rotate_object, _x.add_to_collision_map, _x.keep_level,) = _struct_7d3B.unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_3d3I = struct.Struct("<3d3I")
_struct_3I = struct.Struct("<3I")
_struct_7d3B = struct.Struct("<7d3B")
