#!/usr/bin/python
import sys

if len(sys.argv) < 7:
    print "usage: adjust_rviz_config.py in_file out_file stereo nav nav_local sim (where stereo, nav, nav_local, and sim are true or false)"
    sys.exit(1)
stereo = sys.argv[3]
nav = sys.argv[4]
nav_local = sys.argv[5]
sim = sys.argv[6]
if stereo not in ['true', 'false']:
    print "stereo was not true or false!  usage: adjust_rviz_config.py in_file out_file stereo nav nav_local sim (where stereo, nav, nav_local, and sim are true or false)"
    sys.exit(1)
if nav not in ['true', 'false']:
    print "nav was not true or false!  usage: adjust_rviz_config.py in_file out_file stereo nav nav_local sim (where stereo, nav, nav_local, and sim are true or false)"
    sys.exit(1)
if nav_local not in ['true', 'false']:
    print "nav was not true or false!  usage: adjust_rviz_config.py in_file out_file stereo nav nav_local sim (where stereo, nav, nav_local, and sim are true or false)"
    sys.exit(1)
if sim not in ['true', 'false']:
    print "nav was not true or false!  usage: adjust_rviz_config.py in_file out_file stereo nav nav_local sim (where stereo, nav, nav_local, and sim are true or false)"
    sys.exit(1)


lines = file(sys.argv[1]).readlines()
outfile = file( sys.argv[2], 'w')

outfile.write('### THIS FILE AUTO-GENERATED FROM config/pr2_interactive_manipulation_base.vcg\n')
outfile.write('### IT IS SUGGESTED YOU DO NOT MODIFY THIS FILE.\n')
for line in lines:
    if line[:13] == 'Fixed\ Frame=':
        if nav == 'true' and not nav_local == 'true':
            outfile.write('Fixed\ Frame=/map\n')
        else:
            outfile.write('Fixed\ Frame=/odom_combined\n')
    elif 'Map.Enabled=' in line:
        if nav == 'true' and not nav_local == 'true':
            outfile.write('Map.Enabled=1\n')
        else:
            outfile.write('Map.Enabled=0\n')
    elif 'Nav\ Global\ Path.Enabled=' in line:
        if nav == 'true':
            outfile.write('Nav\ Global\ Path.Enabled=1\n')
        else:
            outfile.write('Nav\ Global\ Path.Enabled=0\n')
    elif 'Nav\ Obstacles.Enabled=' in line:
        if nav == 'true':
            outfile.write('Nav\ Obstacles.Enabled=1\n')
        else:
            outfile.write('Nav\ Obstacles.Enabled=0\n')
    elif 'Nav\ Obstacles.Topic=' in line:
        if nav_local == 'true':
            outfile.write('Nav\ Obstacles.Topic=/move_base_local_node/local_costmap/obstacles\n')
        else:
            outfile.write('Nav\ Obstacles.Topic=/move_base_node/local_costmap/obstacles\n')
    elif 'Nav\ Global\ Path.Topic=' in line:
        if nav_local == 'true':
            outfile.write('Nav\ Global\ Path.Topic=/move_base_local_node/NavfnROS/plan\n')
        else:
            outfile.write('Nav\ Global\ Path.Topic=/move_base_node/NavfnROS/plan\n')
    else:
        outfile.write(line)
outfile.close()
