//#line 2 "/opt/ros/fuerte/stacks/dynamic_reconfigure/templates/ConfigType.h"
// *********************************************************
// 
// File autogenerated for the pr2_grasp_adjust package 
// by the dynamic_reconfigure package.
// Please do not edit.
// 
// ********************************************************/

/***********************************************************
 * Software License Agreement (BSD License)
 *
 *  Copyright (c) 2008, Willow Garage, Inc.
 *  All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *
 *   * Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *   * Redistributions in binary form must reproduce the above
 *     copyright notice, this list of conditions and the following
 *     disclaimer in the documentation and/or other materials provided
 *     with the distribution.
 *   * Neither the name of the Willow Garage nor the names of its
 *     contributors may be used to endorse or promote products derived
 *     from this software without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 *  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 *  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 *  FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 *  COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 *  BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 *  LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 *  CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 *  LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 *  ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 *  POSSIBILITY OF SUCH DAMAGE.
 ***********************************************************/

// Author: Blaise Gassend


#ifndef __pr2_grasp_adjust__ESTIMATECONFIG_H__
#define __pr2_grasp_adjust__ESTIMATECONFIG_H__

#include <dynamic_reconfigure/config_tools.h>
#include <limits>
#include <ros/node_handle.h>
#include <dynamic_reconfigure/ConfigDescription.h>
#include <dynamic_reconfigure/ParamDescription.h>
#include <dynamic_reconfigure/Group.h>
#include <dynamic_reconfigure/config_init_mutex.h>
#include <boost/any.hpp>

namespace pr2_grasp_adjust
{
  class EstimateConfigStatics;
  
  class EstimateConfig
  {
  public:
    class AbstractParamDescription : public dynamic_reconfigure::ParamDescription
    {
    public:
      AbstractParamDescription(std::string n, std::string t, uint32_t l, 
          std::string d, std::string e)
      {
        name = n;
        type = t;
        level = l;
        description = d;
        edit_method = e;
      }
      
      virtual void clamp(EstimateConfig &config, const EstimateConfig &max, const EstimateConfig &min) const = 0;
      virtual void calcLevel(uint32_t &level, const EstimateConfig &config1, const EstimateConfig &config2) const = 0;
      virtual void fromServer(const ros::NodeHandle &nh, EstimateConfig &config) const = 0;
      virtual void toServer(const ros::NodeHandle &nh, const EstimateConfig &config) const = 0;
      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, EstimateConfig &config) const = 0;
      virtual void toMessage(dynamic_reconfigure::Config &msg, const EstimateConfig &config) const = 0;
      virtual void getValue(const EstimateConfig &config, boost::any &val) const = 0;
    };

    typedef boost::shared_ptr<AbstractParamDescription> AbstractParamDescriptionPtr;
    typedef boost::shared_ptr<const AbstractParamDescription> AbstractParamDescriptionConstPtr;
    
    template <class T>
    class ParamDescription : public AbstractParamDescription
    {
    public:
      ParamDescription(std::string name, std::string type, uint32_t level, 
          std::string description, std::string edit_method, T EstimateConfig::* f) :
        AbstractParamDescription(name, type, level, description, edit_method),
        field(f)
      {}

      T (EstimateConfig::* field);

      virtual void clamp(EstimateConfig &config, const EstimateConfig &max, const EstimateConfig &min) const
      {
        if (config.*field > max.*field)
          config.*field = max.*field;
        
        if (config.*field < min.*field)
          config.*field = min.*field;
      }

      virtual void calcLevel(uint32_t &comb_level, const EstimateConfig &config1, const EstimateConfig &config2) const
      {
        if (config1.*field != config2.*field)
          comb_level |= level;
      }

      virtual void fromServer(const ros::NodeHandle &nh, EstimateConfig &config) const
      {
        nh.getParam(name, config.*field);
      }

      virtual void toServer(const ros::NodeHandle &nh, const EstimateConfig &config) const
      {
        nh.setParam(name, config.*field);
      }

      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, EstimateConfig &config) const
      {
        return dynamic_reconfigure::ConfigTools::getParameter(msg, name, config.*field);
      }

      virtual void toMessage(dynamic_reconfigure::Config &msg, const EstimateConfig &config) const
      {
        dynamic_reconfigure::ConfigTools::appendParameter(msg, name, config.*field);
      }

      virtual void getValue(const EstimateConfig &config, boost::any &val) const
      {
        val = config.*field;
      }
    };

    class AbstractGroupDescription : public dynamic_reconfigure::Group
    {
      public:
      AbstractGroupDescription(std::string n, std::string t, int p, int i, bool s)
      {
        name = n;
        type = t;
        parent = p;
        state = s;
        id = i;
      }

      std::vector<AbstractParamDescriptionConstPtr> abstract_parameters;
      bool state;

      virtual void toMessage(dynamic_reconfigure::Config &msg, const boost::any &config) const = 0;
      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, boost::any &config) const =0;
      virtual void updateParams(boost::any &cfg, EstimateConfig &top) const= 0;
      virtual void setInitialState(boost::any &cfg) const = 0;


      void convertParams()
      {
        for(std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = abstract_parameters.begin(); i != abstract_parameters.end(); i++)
        {
          parameters.push_back(dynamic_reconfigure::ParamDescription(**i));
        }
      }
    };

    typedef boost::shared_ptr<AbstractGroupDescription> AbstractGroupDescriptionPtr;
    typedef boost::shared_ptr<const AbstractGroupDescription> AbstractGroupDescriptionConstPtr;

    template<class T, class PT>
    class GroupDescription : public AbstractGroupDescription
    {
    public:
      GroupDescription(std::string name, std::string type, int parent, int id, bool s, T PT::* f) : AbstractGroupDescription(name, type, parent, id, s), field(f)
      {
      }

      GroupDescription(const GroupDescription<T, PT>& g): AbstractGroupDescription(g.name, g.type, g.parent, g.id, g.state), field(g.field), groups(g.groups)
      {
        parameters = g.parameters;
        abstract_parameters = g.abstract_parameters;
      }

      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, boost::any &cfg) const
      {
        PT* config = boost::any_cast<PT*>(cfg);
        if(!dynamic_reconfigure::ConfigTools::getGroupState(msg, name, (*config).*field))
          return false;
        
        for(std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = groups.begin(); i != groups.end(); i++) 
        {
          boost::any n = &((*config).*field);
          if(!(*i)->fromMessage(msg, n))
            return false;
        }

        return true;
      }

      virtual void setInitialState(boost::any &cfg) const
      {
        PT* config = boost::any_cast<PT*>(cfg);
        T* group = &((*config).*field);
        group->state = state;

        for(std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = groups.begin(); i != groups.end(); i++)
        {
          boost::any n = boost::any(&((*config).*field));
          (*i)->setInitialState(n);
        }

      }
      
      virtual void updateParams(boost::any &cfg, EstimateConfig &top) const
      {
        PT* config = boost::any_cast<PT*>(cfg);

        T* f = &((*config).*field);
        f->setParams(top, abstract_parameters);

        for(std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = groups.begin(); i != groups.end(); i++) 
        {
          boost::any n = &((*config).*field);
          (*i)->updateParams(n, top);
        }
      }

      virtual void toMessage(dynamic_reconfigure::Config &msg, const boost::any &cfg) const
      {
        const PT config = boost::any_cast<PT>(cfg);
        dynamic_reconfigure::ConfigTools::appendGroup<T>(msg, name, id, parent, config.*field);

        for(std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = groups.begin(); i != groups.end(); i++)
        {
          (*i)->toMessage(msg, config.*field);
        }
      }

      T (PT::* field);
      std::vector<EstimateConfig::AbstractGroupDescriptionConstPtr> groups;
    };
    
class DEFAULT
{
  public:
    DEFAULT()
    {
      state = true;
      name = "Default";
    }

    void setParams(EstimateConfig &config, const std::vector<AbstractParamDescriptionConstPtr> params)
    {
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = params.begin(); i != params.end(); i++)
      {
        boost::any val;
        (*i)->getValue(config, val);

        if("search_mode"==(*i)->name){search_mode = boost::any_cast<int>(val);}
        if("search_6_dof"==(*i)->name){search_6_dof = boost::any_cast<bool>(val);}
        if("symmetry_weight"==(*i)->name){symmetry_weight = boost::any_cast<double>(val);}
        if("Iyz_weight"==(*i)->name){Iyz_weight = boost::any_cast<double>(val);}
        if("normal_weight"==(*i)->name){normal_weight = boost::any_cast<double>(val);}
        if("point_weight"==(*i)->name){point_weight = boost::any_cast<double>(val);}
        if("centroid_weight"==(*i)->name){centroid_weight = boost::any_cast<double>(val);}
        if("collision_weight"==(*i)->name){collision_weight = boost::any_cast<double>(val);}
        if("grid_step_size"==(*i)->name){grid_step_size = boost::any_cast<double>(val);}
        if("grid_step_num"==(*i)->name){grid_step_num = boost::any_cast<int>(val);}
        if("init_gradient_steps"==(*i)->name){init_gradient_steps = boost::any_cast<int>(val);}
        if("gradient_search_window"==(*i)->name){gradient_search_window = boost::any_cast<int>(val);}
        if("full_gradient_descents"==(*i)->name){full_gradient_descents = boost::any_cast<int>(val);}
        if("linear_step_size"==(*i)->name){linear_step_size = boost::any_cast<double>(val);}
        if("angular_step_size"==(*i)->name){angular_step_size = boost::any_cast<double>(val);}
        if("minimum_score"==(*i)->name){minimum_score = boost::any_cast<double>(val);}
        if("debug_stepping"==(*i)->name){debug_stepping = boost::any_cast<bool>(val);}
        if("debug_freeze"==(*i)->name){debug_freeze = boost::any_cast<bool>(val);}
        if("show_model"==(*i)->name){show_model = boost::any_cast<bool>(val);}
        if("epsilon"==(*i)->name){epsilon = boost::any_cast<double>(val);}
        if("pause_time"==(*i)->name){pause_time = boost::any_cast<double>(val);}
        if("table_height"==(*i)->name){table_height = boost::any_cast<double>(val);}
        if("write_file"==(*i)->name){write_file = boost::any_cast<bool>(val);}
        if("filename"==(*i)->name){filename = boost::any_cast<std::string>(val);}
        if("status"==(*i)->name){status = boost::any_cast<std::string>(val);}
      }
    }

    int search_mode;
bool search_6_dof;
double symmetry_weight;
double Iyz_weight;
double normal_weight;
double point_weight;
double centroid_weight;
double collision_weight;
double grid_step_size;
int grid_step_num;
int init_gradient_steps;
int gradient_search_window;
int full_gradient_descents;
double linear_step_size;
double angular_step_size;
double minimum_score;
bool debug_stepping;
bool debug_freeze;
bool show_model;
double epsilon;
double pause_time;
double table_height;
bool write_file;
std::string filename;
std::string status;

    bool state;
    std::string name;

    
}groups;



//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      int search_mode;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      bool search_6_dof;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      double symmetry_weight;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      double Iyz_weight;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      double normal_weight;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      double point_weight;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      double centroid_weight;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      double collision_weight;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      double grid_step_size;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      int grid_step_num;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      int init_gradient_steps;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      int gradient_search_window;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      int full_gradient_descents;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      double linear_step_size;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      double angular_step_size;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      double minimum_score;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      bool debug_stepping;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      bool debug_freeze;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      bool show_model;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      double epsilon;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      double pause_time;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      double table_height;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      bool write_file;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      std::string filename;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      std::string status;
//#line 255 "/opt/ros/fuerte/stacks/dynamic_reconfigure/templates/ConfigType.h"

    bool __fromMessage__(dynamic_reconfigure::Config &msg)
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      const std::vector<AbstractGroupDescriptionConstPtr> &__group_descriptions__ = __getGroupDescriptions__();

      int count = 0;
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        if ((*i)->fromMessage(msg, *this))
          count++;

      for (std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = __group_descriptions__.begin(); i != __group_descriptions__.end(); i ++)
      {
        if ((*i)->id == 0)
        {
          boost::any n = boost::any(this);
          (*i)->updateParams(n, *this);
          (*i)->fromMessage(msg, n);
        }
      }

      if (count != dynamic_reconfigure::ConfigTools::size(msg))
      {
        ROS_ERROR("EstimateConfig::__fromMessage__ called with an unexpected parameter.");
        ROS_ERROR("Booleans:");
        for (unsigned int i = 0; i < msg.bools.size(); i++)
          ROS_ERROR("  %s", msg.bools[i].name.c_str());
        ROS_ERROR("Integers:");
        for (unsigned int i = 0; i < msg.ints.size(); i++)
          ROS_ERROR("  %s", msg.ints[i].name.c_str());
        ROS_ERROR("Doubles:");
        for (unsigned int i = 0; i < msg.doubles.size(); i++)
          ROS_ERROR("  %s", msg.doubles[i].name.c_str());
        ROS_ERROR("Strings:");
        for (unsigned int i = 0; i < msg.strs.size(); i++)
          ROS_ERROR("  %s", msg.strs[i].name.c_str());
        // @todo Check that there are no duplicates. Make this error more
        // explicit.
        return false;
      }
      return true;
    }

    // This version of __toMessage__ is used during initialization of
    // statics when __getParamDescriptions__ can't be called yet.
    void __toMessage__(dynamic_reconfigure::Config &msg, const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__, const std::vector<AbstractGroupDescriptionConstPtr> &__group_descriptions__) const
    {
      dynamic_reconfigure::ConfigTools::clear(msg);
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->toMessage(msg, *this);

      for (std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = __group_descriptions__.begin(); i != __group_descriptions__.end(); i++)
      {
        if((*i)->id == 0)
        {
          (*i)->toMessage(msg, *this);
        }
      }
    }
    
    void __toMessage__(dynamic_reconfigure::Config &msg) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      const std::vector<AbstractGroupDescriptionConstPtr> &__group_descriptions__ = __getGroupDescriptions__();
      __toMessage__(msg, __param_descriptions__, __group_descriptions__);
    }
    
    void __toServer__(const ros::NodeHandle &nh) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->toServer(nh, *this);
    }

    void __fromServer__(const ros::NodeHandle &nh)
    {
      static bool setup=false;

      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->fromServer(nh, *this);

      const std::vector<AbstractGroupDescriptionConstPtr> &__group_descriptions__ = __getGroupDescriptions__();
      for (std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = __group_descriptions__.begin(); i != __group_descriptions__.end(); i++){
        if (!setup && (*i)->id == 0) {
          setup = true;
          boost::any n = boost::any(this);
          (*i)->setInitialState(n);
        }
      }
    }

    void __clamp__()
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      const EstimateConfig &__max__ = __getMax__();
      const EstimateConfig &__min__ = __getMin__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->clamp(*this, __max__, __min__);
    }

    uint32_t __level__(const EstimateConfig &config) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      uint32_t level = 0;
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->calcLevel(level, config, *this);
      return level;
    }
    
    static const dynamic_reconfigure::ConfigDescription &__getDescriptionMessage__();
    static const EstimateConfig &__getDefault__();
    static const EstimateConfig &__getMax__();
    static const EstimateConfig &__getMin__();
    static const std::vector<AbstractParamDescriptionConstPtr> &__getParamDescriptions__();
    static const std::vector<AbstractGroupDescriptionConstPtr> &__getGroupDescriptions__();
    
  private:
    static const EstimateConfigStatics *__get_statics__();
  };
  
  template <> // Max and min are ignored for strings.
  inline void EstimateConfig::ParamDescription<std::string>::clamp(EstimateConfig &config, const EstimateConfig &max, const EstimateConfig &min) const
  {
    return;
  }

  class EstimateConfigStatics
  {
    friend class EstimateConfig;
    
    EstimateConfigStatics()
    {
EstimateConfig::GroupDescription<EstimateConfig::DEFAULT, EstimateConfig> Default("Default", "", 0, 0, true, &EstimateConfig::groups);
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __min__.search_mode = 0;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __max__.search_mode = 3;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __default__.search_mode = 0;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      Default.abstract_parameters.push_back(EstimateConfig::AbstractParamDescriptionConstPtr(new EstimateConfig::ParamDescription<int>("search_mode", "int", 20, "Int enum", "{'enum_description': 'An enum to set the mode.', 'enum': [{'srcline': 82, 'description': 'Perform global search on grid.', 'srcfile': '../cfg/Estimate.cfg', 'cconsttype': 'const int', 'value': 0, 'ctype': 'int', 'type': 'int', 'name': 'global_search'}, {'srcline': 83, 'description': 'Perform local search (includes some rotational perturbations).', 'srcfile': '../cfg/Estimate.cfg', 'cconsttype': 'const int', 'value': 1, 'ctype': 'int', 'type': 'int', 'name': 'local_search'}, {'srcline': 84, 'description': 'For debugging a single pose.', 'srcfile': '../cfg/Estimate.cfg', 'cconsttype': 'const int', 'value': 2, 'ctype': 'int', 'type': 'int', 'name': 'single_pose'}]}", &EstimateConfig::search_mode)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __param_descriptions__.push_back(EstimateConfig::AbstractParamDescriptionConstPtr(new EstimateConfig::ParamDescription<int>("search_mode", "int", 20, "Int enum", "{'enum_description': 'An enum to set the mode.', 'enum': [{'srcline': 82, 'description': 'Perform global search on grid.', 'srcfile': '../cfg/Estimate.cfg', 'cconsttype': 'const int', 'value': 0, 'ctype': 'int', 'type': 'int', 'name': 'global_search'}, {'srcline': 83, 'description': 'Perform local search (includes some rotational perturbations).', 'srcfile': '../cfg/Estimate.cfg', 'cconsttype': 'const int', 'value': 1, 'ctype': 'int', 'type': 'int', 'name': 'local_search'}, {'srcline': 84, 'description': 'For debugging a single pose.', 'srcfile': '../cfg/Estimate.cfg', 'cconsttype': 'const int', 'value': 2, 'ctype': 'int', 'type': 'int', 'name': 'single_pose'}]}", &EstimateConfig::search_mode)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __min__.search_6_dof = 0;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __max__.search_6_dof = 1;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __default__.search_6_dof = 0;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      Default.abstract_parameters.push_back(EstimateConfig::AbstractParamDescriptionConstPtr(new EstimateConfig::ParamDescription<bool>("search_6_dof", "bool", 12, "Enable 6-dof search", "", &EstimateConfig::search_6_dof)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __param_descriptions__.push_back(EstimateConfig::AbstractParamDescriptionConstPtr(new EstimateConfig::ParamDescription<bool>("search_6_dof", "bool", 12, "Enable 6-dof search", "", &EstimateConfig::search_6_dof)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __min__.symmetry_weight = -100.0;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __max__.symmetry_weight = 100.0;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __default__.symmetry_weight = 50.0;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      Default.abstract_parameters.push_back(EstimateConfig::AbstractParamDescriptionConstPtr(new EstimateConfig::ParamDescription<double>("symmetry_weight", "double", 2, "symmetry_weight", "", &EstimateConfig::symmetry_weight)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __param_descriptions__.push_back(EstimateConfig::AbstractParamDescriptionConstPtr(new EstimateConfig::ParamDescription<double>("symmetry_weight", "double", 2, "symmetry_weight", "", &EstimateConfig::symmetry_weight)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __min__.Iyz_weight = -100.0;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __max__.Iyz_weight = 100.0;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __default__.Iyz_weight = -10.0;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      Default.abstract_parameters.push_back(EstimateConfig::AbstractParamDescriptionConstPtr(new EstimateConfig::ParamDescription<double>("Iyz_weight", "double", 4, "Iyz", "", &EstimateConfig::Iyz_weight)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __param_descriptions__.push_back(EstimateConfig::AbstractParamDescriptionConstPtr(new EstimateConfig::ParamDescription<double>("Iyz_weight", "double", 4, "Iyz", "", &EstimateConfig::Iyz_weight)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __min__.normal_weight = -100.0;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __max__.normal_weight = 100.0;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __default__.normal_weight = 50.0;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      Default.abstract_parameters.push_back(EstimateConfig::AbstractParamDescriptionConstPtr(new EstimateConfig::ParamDescription<double>("normal_weight", "double", 8, "normal_weight", "", &EstimateConfig::normal_weight)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __param_descriptions__.push_back(EstimateConfig::AbstractParamDescriptionConstPtr(new EstimateConfig::ParamDescription<double>("normal_weight", "double", 8, "normal_weight", "", &EstimateConfig::normal_weight)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __min__.point_weight = -100.0;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __max__.point_weight = 100.0;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __default__.point_weight = 0.01;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      Default.abstract_parameters.push_back(EstimateConfig::AbstractParamDescriptionConstPtr(new EstimateConfig::ParamDescription<double>("point_weight", "double", 3, "point_weight", "", &EstimateConfig::point_weight)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __param_descriptions__.push_back(EstimateConfig::AbstractParamDescriptionConstPtr(new EstimateConfig::ParamDescription<double>("point_weight", "double", 3, "point_weight", "", &EstimateConfig::point_weight)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __min__.centroid_weight = -100.0;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __max__.centroid_weight = 100.0;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __default__.centroid_weight = -30.0;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      Default.abstract_parameters.push_back(EstimateConfig::AbstractParamDescriptionConstPtr(new EstimateConfig::ParamDescription<double>("centroid_weight", "double", 1, "centroid_weight", "", &EstimateConfig::centroid_weight)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __param_descriptions__.push_back(EstimateConfig::AbstractParamDescriptionConstPtr(new EstimateConfig::ParamDescription<double>("centroid_weight", "double", 1, "centroid_weight", "", &EstimateConfig::centroid_weight)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __min__.collision_weight = -100.0;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __max__.collision_weight = 100.0;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __default__.collision_weight = -1.5;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      Default.abstract_parameters.push_back(EstimateConfig::AbstractParamDescriptionConstPtr(new EstimateConfig::ParamDescription<double>("collision_weight", "double", 5, "collision_weight", "", &EstimateConfig::collision_weight)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __param_descriptions__.push_back(EstimateConfig::AbstractParamDescriptionConstPtr(new EstimateConfig::ParamDescription<double>("collision_weight", "double", 5, "collision_weight", "", &EstimateConfig::collision_weight)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __min__.grid_step_size = 0.01;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __max__.grid_step_size = 0.05;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __default__.grid_step_size = 0.03;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      Default.abstract_parameters.push_back(EstimateConfig::AbstractParamDescriptionConstPtr(new EstimateConfig::ParamDescription<double>("grid_step_size", "double", 8, "seed pose spacing (meters)", "", &EstimateConfig::grid_step_size)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __param_descriptions__.push_back(EstimateConfig::AbstractParamDescriptionConstPtr(new EstimateConfig::ParamDescription<double>("grid_step_size", "double", 8, "seed pose spacing (meters)", "", &EstimateConfig::grid_step_size)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __min__.grid_step_num = 0;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __max__.grid_step_num = 5;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __default__.grid_step_num = 1;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      Default.abstract_parameters.push_back(EstimateConfig::AbstractParamDescriptionConstPtr(new EstimateConfig::ParamDescription<int>("grid_step_num", "int", 8, "seed pose grid size (2n+1 by 2n+1)", "", &EstimateConfig::grid_step_num)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __param_descriptions__.push_back(EstimateConfig::AbstractParamDescriptionConstPtr(new EstimateConfig::ParamDescription<int>("grid_step_num", "int", 8, "seed pose grid size (2n+1 by 2n+1)", "", &EstimateConfig::grid_step_num)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __min__.init_gradient_steps = 0;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __max__.init_gradient_steps = 50;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __default__.init_gradient_steps = 2;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      Default.abstract_parameters.push_back(EstimateConfig::AbstractParamDescriptionConstPtr(new EstimateConfig::ParamDescription<int>("init_gradient_steps", "int", 8, "Number of steps to do on each seed pose", "", &EstimateConfig::init_gradient_steps)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __param_descriptions__.push_back(EstimateConfig::AbstractParamDescriptionConstPtr(new EstimateConfig::ParamDescription<int>("init_gradient_steps", "int", 8, "Number of steps to do on each seed pose", "", &EstimateConfig::init_gradient_steps)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __min__.gradient_search_window = 1;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __max__.gradient_search_window = 3;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __default__.gradient_search_window = 1;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      Default.abstract_parameters.push_back(EstimateConfig::AbstractParamDescriptionConstPtr(new EstimateConfig::ParamDescription<int>("gradient_search_window", "int", 10, "gradient search window", "", &EstimateConfig::gradient_search_window)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __param_descriptions__.push_back(EstimateConfig::AbstractParamDescriptionConstPtr(new EstimateConfig::ParamDescription<int>("gradient_search_window", "int", 10, "gradient search window", "", &EstimateConfig::gradient_search_window)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __min__.full_gradient_descents = 1;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __max__.full_gradient_descents = 20;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __default__.full_gradient_descents = 5;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      Default.abstract_parameters.push_back(EstimateConfig::AbstractParamDescriptionConstPtr(new EstimateConfig::ParamDescription<int>("full_gradient_descents", "int", 8, "Number of poses to do a full descent on", "", &EstimateConfig::full_gradient_descents)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __param_descriptions__.push_back(EstimateConfig::AbstractParamDescriptionConstPtr(new EstimateConfig::ParamDescription<int>("full_gradient_descents", "int", 8, "Number of poses to do a full descent on", "", &EstimateConfig::full_gradient_descents)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __min__.linear_step_size = 0.0;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __max__.linear_step_size = 0.01;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __default__.linear_step_size = 0.002;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      Default.abstract_parameters.push_back(EstimateConfig::AbstractParamDescriptionConstPtr(new EstimateConfig::ParamDescription<double>("linear_step_size", "double", 9, "linear step size", "", &EstimateConfig::linear_step_size)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __param_descriptions__.push_back(EstimateConfig::AbstractParamDescriptionConstPtr(new EstimateConfig::ParamDescription<double>("linear_step_size", "double", 9, "linear step size", "", &EstimateConfig::linear_step_size)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __min__.angular_step_size = 0.0;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __max__.angular_step_size = 0.5;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __default__.angular_step_size = 0.1;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      Default.abstract_parameters.push_back(EstimateConfig::AbstractParamDescriptionConstPtr(new EstimateConfig::ParamDescription<double>("angular_step_size", "double", 10, "angular step size", "", &EstimateConfig::angular_step_size)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __param_descriptions__.push_back(EstimateConfig::AbstractParamDescriptionConstPtr(new EstimateConfig::ParamDescription<double>("angular_step_size", "double", 10, "angular step size", "", &EstimateConfig::angular_step_size)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __min__.minimum_score = 0.0;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __max__.minimum_score = 1.0;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __default__.minimum_score = 0.6;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      Default.abstract_parameters.push_back(EstimateConfig::AbstractParamDescriptionConstPtr(new EstimateConfig::ParamDescription<double>("minimum_score", "double", 10, "minimum grasp quality score to return [0,1]", "", &EstimateConfig::minimum_score)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __param_descriptions__.push_back(EstimateConfig::AbstractParamDescriptionConstPtr(new EstimateConfig::ParamDescription<double>("minimum_score", "double", 10, "minimum grasp quality score to return [0,1]", "", &EstimateConfig::minimum_score)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __min__.debug_stepping = 0;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __max__.debug_stepping = 1;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __default__.debug_stepping = 0;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      Default.abstract_parameters.push_back(EstimateConfig::AbstractParamDescriptionConstPtr(new EstimateConfig::ParamDescription<bool>("debug_stepping", "bool", 12, "Take slow steps", "", &EstimateConfig::debug_stepping)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __param_descriptions__.push_back(EstimateConfig::AbstractParamDescriptionConstPtr(new EstimateConfig::ParamDescription<bool>("debug_stepping", "bool", 12, "Take slow steps", "", &EstimateConfig::debug_stepping)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __min__.debug_freeze = 0;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __max__.debug_freeze = 1;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __default__.debug_freeze = 0;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      Default.abstract_parameters.push_back(EstimateConfig::AbstractParamDescriptionConstPtr(new EstimateConfig::ParamDescription<bool>("debug_freeze", "bool", 12, "No gradient desent", "", &EstimateConfig::debug_freeze)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __param_descriptions__.push_back(EstimateConfig::AbstractParamDescriptionConstPtr(new EstimateConfig::ParamDescription<bool>("debug_freeze", "bool", 12, "No gradient desent", "", &EstimateConfig::debug_freeze)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __min__.show_model = 0;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __max__.show_model = 1;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __default__.show_model = 0;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      Default.abstract_parameters.push_back(EstimateConfig::AbstractParamDescriptionConstPtr(new EstimateConfig::ParamDescription<bool>("show_model", "bool", 12, "No gradient desent", "", &EstimateConfig::show_model)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __param_descriptions__.push_back(EstimateConfig::AbstractParamDescriptionConstPtr(new EstimateConfig::ParamDescription<bool>("show_model", "bool", 12, "No gradient desent", "", &EstimateConfig::show_model)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __min__.epsilon = 1e-06;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __max__.epsilon = 1.0;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __default__.epsilon = 0.0001;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      Default.abstract_parameters.push_back(EstimateConfig::AbstractParamDescriptionConstPtr(new EstimateConfig::ParamDescription<double>("epsilon", "double", 13, "epsilon", "", &EstimateConfig::epsilon)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __param_descriptions__.push_back(EstimateConfig::AbstractParamDescriptionConstPtr(new EstimateConfig::ParamDescription<double>("epsilon", "double", 13, "epsilon", "", &EstimateConfig::epsilon)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __min__.pause_time = 0.0;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __max__.pause_time = 1.0;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __default__.pause_time = 0.1;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      Default.abstract_parameters.push_back(EstimateConfig::AbstractParamDescriptionConstPtr(new EstimateConfig::ParamDescription<double>("pause_time", "double", 14, "pause_time", "", &EstimateConfig::pause_time)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __param_descriptions__.push_back(EstimateConfig::AbstractParamDescriptionConstPtr(new EstimateConfig::ParamDescription<double>("pause_time", "double", 14, "pause_time", "", &EstimateConfig::pause_time)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __min__.table_height = 0.0;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __max__.table_height = 1.0;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __default__.table_height = 0.74;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      Default.abstract_parameters.push_back(EstimateConfig::AbstractParamDescriptionConstPtr(new EstimateConfig::ParamDescription<double>("table_height", "double", 8, "offset_z", "", &EstimateConfig::table_height)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __param_descriptions__.push_back(EstimateConfig::AbstractParamDescriptionConstPtr(new EstimateConfig::ParamDescription<double>("table_height", "double", 8, "offset_z", "", &EstimateConfig::table_height)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __min__.write_file = 0;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __max__.write_file = 1;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __default__.write_file = 0;
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      Default.abstract_parameters.push_back(EstimateConfig::AbstractParamDescriptionConstPtr(new EstimateConfig::ParamDescription<bool>("write_file", "bool", 91, "When true, output file is open", "", &EstimateConfig::write_file)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __param_descriptions__.push_back(EstimateConfig::AbstractParamDescriptionConstPtr(new EstimateConfig::ParamDescription<bool>("write_file", "bool", 91, "When true, output file is open", "", &EstimateConfig::write_file)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __min__.filename = "";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __max__.filename = "";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __default__.filename = "training_features.txt";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      Default.abstract_parameters.push_back(EstimateConfig::AbstractParamDescriptionConstPtr(new EstimateConfig::ParamDescription<std::string>("filename", "str", 99, "For setting the output file name", "", &EstimateConfig::filename)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __param_descriptions__.push_back(EstimateConfig::AbstractParamDescriptionConstPtr(new EstimateConfig::ParamDescription<std::string>("filename", "str", 99, "For setting the output file name", "", &EstimateConfig::filename)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __min__.status = "";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __max__.status = "";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __default__.status = "status";
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      Default.abstract_parameters.push_back(EstimateConfig::AbstractParamDescriptionConstPtr(new EstimateConfig::ParamDescription<std::string>("status", "str", 99, "For returning text to reconfigure gui.", "", &EstimateConfig::status)));
//#line 259 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __param_descriptions__.push_back(EstimateConfig::AbstractParamDescriptionConstPtr(new EstimateConfig::ParamDescription<std::string>("status", "str", 99, "For returning text to reconfigure gui.", "", &EstimateConfig::status)));
//#line 233 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      Default.convertParams();
//#line 233 "/opt/ros/fuerte/stacks/dynamic_reconfigure/src/dynamic_reconfigure/parameter_generator.py"
      __group_descriptions__.push_back(EstimateConfig::AbstractGroupDescriptionConstPtr(new EstimateConfig::GroupDescription<EstimateConfig::DEFAULT, EstimateConfig>(Default)));
//#line 390 "/opt/ros/fuerte/stacks/dynamic_reconfigure/templates/ConfigType.h"
    
      for (std::vector<EstimateConfig::AbstractGroupDescriptionConstPtr>::const_iterator i = __group_descriptions__.begin(); i != __group_descriptions__.end(); i++)
      {
        __description_message__.groups.push_back(**i);
      }
      __max__.__toMessage__(__description_message__.max, __param_descriptions__, __group_descriptions__); 
      __min__.__toMessage__(__description_message__.min, __param_descriptions__, __group_descriptions__); 
      __default__.__toMessage__(__description_message__.dflt, __param_descriptions__, __group_descriptions__); 
    }
    std::vector<EstimateConfig::AbstractParamDescriptionConstPtr> __param_descriptions__;
    std::vector<EstimateConfig::AbstractGroupDescriptionConstPtr> __group_descriptions__;
    EstimateConfig __max__;
    EstimateConfig __min__;
    EstimateConfig __default__;
    dynamic_reconfigure::ConfigDescription __description_message__;

    static const EstimateConfigStatics *get_instance()
    {
      // Split this off in a separate function because I know that
      // instance will get initialized the first time get_instance is
      // called, and I am guaranteeing that get_instance gets called at
      // most once.
      static EstimateConfigStatics instance;
      return &instance;
    }
  };

  inline const dynamic_reconfigure::ConfigDescription &EstimateConfig::__getDescriptionMessage__() 
  {
    return __get_statics__()->__description_message__;
  }

  inline const EstimateConfig &EstimateConfig::__getDefault__()
  {
    return __get_statics__()->__default__;
  }
  
  inline const EstimateConfig &EstimateConfig::__getMax__()
  {
    return __get_statics__()->__max__;
  }
  
  inline const EstimateConfig &EstimateConfig::__getMin__()
  {
    return __get_statics__()->__min__;
  }
  
  inline const std::vector<EstimateConfig::AbstractParamDescriptionConstPtr> &EstimateConfig::__getParamDescriptions__()
  {
    return __get_statics__()->__param_descriptions__;
  }

  inline const std::vector<EstimateConfig::AbstractGroupDescriptionConstPtr> &EstimateConfig::__getGroupDescriptions__()
  {
    return __get_statics__()->__group_descriptions__;
  }

  inline const EstimateConfigStatics *EstimateConfig::__get_statics__()
  {
    const static EstimateConfigStatics *statics;
  
    if (statics) // Common case
      return statics;

    boost::mutex::scoped_lock lock(dynamic_reconfigure::__init_mutex__);

    if (statics) // In case we lost a race.
      return statics;

    statics = EstimateConfigStatics::get_instance();
    
    return statics;
  }

//#line 68 "../cfg/Estimate.cfg"
      const int Estimate_id_pos_error = 1;
//#line 69 "../cfg/Estimate.cfg"
      const int Estimate_id_alignment_error = 2;
//#line 70 "../cfg/Estimate.cfg"
      const int Estimate_id_points_enclosed = 3;
//#line 71 "../cfg/Estimate.cfg"
      const int Estimate_id_collisions = 4;
//#line 72 "../cfg/Estimate.cfg"
      const int Estimate_id_linear_step = 5;
//#line 73 "../cfg/Estimate.cfg"
      const int Estimate_id_roll_step = 6;
//#line 74 "../cfg/Estimate.cfg"
      const int Estimate_id_voxel_size = 7;
//#line 82 "../cfg/Estimate.cfg"
      const int Estimate_global_search = 0;
//#line 83 "../cfg/Estimate.cfg"
      const int Estimate_local_search = 1;
//#line 84 "../cfg/Estimate.cfg"
      const int Estimate_single_pose = 2;
}

#endif // __ESTIMATERECONFIGURATOR_H__
