"""autogenerated by genpy from pr2_object_manipulation_msgs/CameraFocus.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import geometry_msgs.msg
import std_msgs.msg

class CameraFocus(genpy.Message):
  _md5sum = "1f24a2adf05af0b5a976acfd3e0afc07"
  _type = "pr2_object_manipulation_msgs/CameraFocus"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """# Requests that the RViz 3D camera be focused at this point
# still under construction

geometry_msgs/PointStamped focal_point
================================================================================
MSG: geometry_msgs/PointStamped
# This represents a Point with reference coordinate frame and timestamp
Header header
Point point

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

"""
  __slots__ = ['focal_point']
  _slot_types = ['geometry_msgs/PointStamped']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       focal_point

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(CameraFocus, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.focal_point is None:
        self.focal_point = geometry_msgs.msg.PointStamped()
    else:
      self.focal_point = geometry_msgs.msg.PointStamped()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.focal_point.header.seq, _x.focal_point.header.stamp.secs, _x.focal_point.header.stamp.nsecs))
      _x = self.focal_point.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_3d.pack(_x.focal_point.point.x, _x.focal_point.point.y, _x.focal_point.point.z))
    except struct.error as se: self._check_types(se)
    except TypeError as te: self._check_types(te)

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.focal_point is None:
        self.focal_point = geometry_msgs.msg.PointStamped()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.focal_point.header.seq, _x.focal_point.header.stamp.secs, _x.focal_point.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.focal_point.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.focal_point.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 24
      (_x.focal_point.point.x, _x.focal_point.point.y, _x.focal_point.point.z,) = _struct_3d.unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.focal_point.header.seq, _x.focal_point.header.stamp.secs, _x.focal_point.header.stamp.nsecs))
      _x = self.focal_point.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_3d.pack(_x.focal_point.point.x, _x.focal_point.point.y, _x.focal_point.point.z))
    except struct.error as se: self._check_types(se)
    except TypeError as te: self._check_types(te)

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.focal_point is None:
        self.focal_point = geometry_msgs.msg.PointStamped()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.focal_point.header.seq, _x.focal_point.header.stamp.secs, _x.focal_point.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.focal_point.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.focal_point.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 24
      (_x.focal_point.point.x, _x.focal_point.point.y, _x.focal_point.point.z,) = _struct_3d.unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_3I = struct.Struct("<3I")
_struct_3d = struct.Struct("<3d")
