"""autogenerated by genpy from pr2_object_manipulation_msgs/ImageClick.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import pr2_object_manipulation_msgs.msg
import geometry_msgs.msg
import std_msgs.msg

class ImageClick(genpy.Message):
  _md5sum = "6549d856fa5d392f2ffbeaf0a2f80931"
  _type = "pr2_object_manipulation_msgs/ImageClick"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """# Info about a user click on an image

# The ray in 3d space resulting from the click
Ray ray

# The frame_if of the camera that the click was in
string camera_frame_id
================================================================================
MSG: pr2_object_manipulation_msgs/Ray
# Represents a ray through space.
# Could probably move to a more general location

Header header

# the origin of the ray
geometry_msgs/Point origin

# the direction of the ray
geometry_msgs/Vector3 direction
================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 

float64 x
float64 y
float64 z
"""
  __slots__ = ['ray','camera_frame_id']
  _slot_types = ['pr2_object_manipulation_msgs/Ray','string']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       ray,camera_frame_id

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(ImageClick, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.ray is None:
        self.ray = pr2_object_manipulation_msgs.msg.Ray()
      if self.camera_frame_id is None:
        self.camera_frame_id = ''
    else:
      self.ray = pr2_object_manipulation_msgs.msg.Ray()
      self.camera_frame_id = ''

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.ray.header.seq, _x.ray.header.stamp.secs, _x.ray.header.stamp.nsecs))
      _x = self.ray.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_6d.pack(_x.ray.origin.x, _x.ray.origin.y, _x.ray.origin.z, _x.ray.direction.x, _x.ray.direction.y, _x.ray.direction.z))
      _x = self.camera_frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
    except struct.error as se: self._check_types(se)
    except TypeError as te: self._check_types(te)

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.ray is None:
        self.ray = pr2_object_manipulation_msgs.msg.Ray()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.ray.header.seq, _x.ray.header.stamp.secs, _x.ray.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.ray.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.ray.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 48
      (_x.ray.origin.x, _x.ray.origin.y, _x.ray.origin.z, _x.ray.direction.x, _x.ray.direction.y, _x.ray.direction.z,) = _struct_6d.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.camera_frame_id = str[start:end].decode('utf-8')
      else:
        self.camera_frame_id = str[start:end]
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.ray.header.seq, _x.ray.header.stamp.secs, _x.ray.header.stamp.nsecs))
      _x = self.ray.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_6d.pack(_x.ray.origin.x, _x.ray.origin.y, _x.ray.origin.z, _x.ray.direction.x, _x.ray.direction.y, _x.ray.direction.z))
      _x = self.camera_frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
    except struct.error as se: self._check_types(se)
    except TypeError as te: self._check_types(te)

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.ray is None:
        self.ray = pr2_object_manipulation_msgs.msg.Ray()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.ray.header.seq, _x.ray.header.stamp.secs, _x.ray.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.ray.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.ray.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 48
      (_x.ray.origin.x, _x.ray.origin.y, _x.ray.origin.z, _x.ray.direction.x, _x.ray.direction.y, _x.ray.direction.z,) = _struct_6d.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.camera_frame_id = str[start:end].decode('utf-8')
      else:
        self.camera_frame_id = str[start:end]
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_3I = struct.Struct("<3I")
_struct_6d = struct.Struct("<6d")
