"""autogenerated by genpy from fast_plane_detection/Plane.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import geometry_msgs.msg
import std_msgs.msg

class Plane(genpy.Message):
  _md5sum = "e876d3c2247eeda0c0207fae33ce01a9"
  _type = "fast_plane_detection/Plane"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """# Informs that a plane has been detected at a given location

# The pose gives you the transform that take you to the coordinate system
# of the plane, with the origin somewhere in the plane and the 
# z axis normal to the plane
geometry_msgs/PoseStamped pose
			  
# Point + normal vector of the plane
geometry_msgs/PointStamped plane_point
geometry_msgs/Vector3Stamped normal
geometry_msgs/PointStamped slave_point
			   
# These values give you the observed extents of the plane, along x and y,
# in the plane's own coordinate system (above)
# there is no guarantee that the origin of the plane coordinate system is
# inside the boundary defined by these values. 
geometry_msgs/Point32 top_left
geometry_msgs/Point32 top_right

geometry_msgs/Point32 bottom_left
geometry_msgs/Point32 bottom_right
 
# There is no guarantee that the plane doe NOT extend further than these 
# values; this is just as far as we've observed it.

# Whether the detection has succeeded or failed
int32 SUCCESS = 1
int32 FEW_INLIERS = 2
int32 NO_PLANE = 3
int32 OTHER_ERROR = 4
int32 result

# inliers over whole region
float32 percentage_inliers
# inliers of valid disparities
int32 percentage_disp_inliers
# number of valid disparities
int32 percentage_valid_disp

# confidence indicators of plane detection
# mean squared error
float32 error

================================================================================
MSG: geometry_msgs/PoseStamped
# A Pose with reference coordinate frame and timestamp
Header header
Pose pose

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: geometry_msgs/PointStamped
# This represents a Point with reference coordinate frame and timestamp
Header header
Point point

================================================================================
MSG: geometry_msgs/Vector3Stamped
# This represents a Vector3 with reference coordinate frame and timestamp
Header header
Vector3 vector

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 

float64 x
float64 y
float64 z
================================================================================
MSG: geometry_msgs/Point32
# This contains the position of a point in free space(with 32 bits of precision).
# It is recommeded to use Point wherever possible instead of Point32.  
# 
# This recommendation is to promote interoperability.  
#
# This message is designed to take up less space when sending
# lots of points at once, as in the case of a PointCloud.  

float32 x
float32 y
float32 z
"""
  # Pseudo-constants
  SUCCESS = 1
  FEW_INLIERS = 2
  NO_PLANE = 3
  OTHER_ERROR = 4

  __slots__ = ['pose','plane_point','normal','slave_point','top_left','top_right','bottom_left','bottom_right','result','percentage_inliers','percentage_disp_inliers','percentage_valid_disp','error']
  _slot_types = ['geometry_msgs/PoseStamped','geometry_msgs/PointStamped','geometry_msgs/Vector3Stamped','geometry_msgs/PointStamped','geometry_msgs/Point32','geometry_msgs/Point32','geometry_msgs/Point32','geometry_msgs/Point32','int32','float32','int32','int32','float32']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       pose,plane_point,normal,slave_point,top_left,top_right,bottom_left,bottom_right,result,percentage_inliers,percentage_disp_inliers,percentage_valid_disp,error

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(Plane, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.pose is None:
        self.pose = geometry_msgs.msg.PoseStamped()
      if self.plane_point is None:
        self.plane_point = geometry_msgs.msg.PointStamped()
      if self.normal is None:
        self.normal = geometry_msgs.msg.Vector3Stamped()
      if self.slave_point is None:
        self.slave_point = geometry_msgs.msg.PointStamped()
      if self.top_left is None:
        self.top_left = geometry_msgs.msg.Point32()
      if self.top_right is None:
        self.top_right = geometry_msgs.msg.Point32()
      if self.bottom_left is None:
        self.bottom_left = geometry_msgs.msg.Point32()
      if self.bottom_right is None:
        self.bottom_right = geometry_msgs.msg.Point32()
      if self.result is None:
        self.result = 0
      if self.percentage_inliers is None:
        self.percentage_inliers = 0.
      if self.percentage_disp_inliers is None:
        self.percentage_disp_inliers = 0
      if self.percentage_valid_disp is None:
        self.percentage_valid_disp = 0
      if self.error is None:
        self.error = 0.
    else:
      self.pose = geometry_msgs.msg.PoseStamped()
      self.plane_point = geometry_msgs.msg.PointStamped()
      self.normal = geometry_msgs.msg.Vector3Stamped()
      self.slave_point = geometry_msgs.msg.PointStamped()
      self.top_left = geometry_msgs.msg.Point32()
      self.top_right = geometry_msgs.msg.Point32()
      self.bottom_left = geometry_msgs.msg.Point32()
      self.bottom_right = geometry_msgs.msg.Point32()
      self.result = 0
      self.percentage_inliers = 0.
      self.percentage_disp_inliers = 0
      self.percentage_valid_disp = 0
      self.error = 0.

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.pose.header.seq, _x.pose.header.stamp.secs, _x.pose.header.stamp.nsecs))
      _x = self.pose.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_7d3I.pack(_x.pose.pose.position.x, _x.pose.pose.position.y, _x.pose.pose.position.z, _x.pose.pose.orientation.x, _x.pose.pose.orientation.y, _x.pose.pose.orientation.z, _x.pose.pose.orientation.w, _x.plane_point.header.seq, _x.plane_point.header.stamp.secs, _x.plane_point.header.stamp.nsecs))
      _x = self.plane_point.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_3d3I.pack(_x.plane_point.point.x, _x.plane_point.point.y, _x.plane_point.point.z, _x.normal.header.seq, _x.normal.header.stamp.secs, _x.normal.header.stamp.nsecs))
      _x = self.normal.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_3d3I.pack(_x.normal.vector.x, _x.normal.vector.y, _x.normal.vector.z, _x.slave_point.header.seq, _x.slave_point.header.stamp.secs, _x.slave_point.header.stamp.nsecs))
      _x = self.slave_point.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_3d12fif2if.pack(_x.slave_point.point.x, _x.slave_point.point.y, _x.slave_point.point.z, _x.top_left.x, _x.top_left.y, _x.top_left.z, _x.top_right.x, _x.top_right.y, _x.top_right.z, _x.bottom_left.x, _x.bottom_left.y, _x.bottom_left.z, _x.bottom_right.x, _x.bottom_right.y, _x.bottom_right.z, _x.result, _x.percentage_inliers, _x.percentage_disp_inliers, _x.percentage_valid_disp, _x.error))
    except struct.error as se: self._check_types(se)
    except TypeError as te: self._check_types(te)

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.pose is None:
        self.pose = geometry_msgs.msg.PoseStamped()
      if self.plane_point is None:
        self.plane_point = geometry_msgs.msg.PointStamped()
      if self.normal is None:
        self.normal = geometry_msgs.msg.Vector3Stamped()
      if self.slave_point is None:
        self.slave_point = geometry_msgs.msg.PointStamped()
      if self.top_left is None:
        self.top_left = geometry_msgs.msg.Point32()
      if self.top_right is None:
        self.top_right = geometry_msgs.msg.Point32()
      if self.bottom_left is None:
        self.bottom_left = geometry_msgs.msg.Point32()
      if self.bottom_right is None:
        self.bottom_right = geometry_msgs.msg.Point32()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.pose.header.seq, _x.pose.header.stamp.secs, _x.pose.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.pose.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.pose.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 68
      (_x.pose.pose.position.x, _x.pose.pose.position.y, _x.pose.pose.position.z, _x.pose.pose.orientation.x, _x.pose.pose.orientation.y, _x.pose.pose.orientation.z, _x.pose.pose.orientation.w, _x.plane_point.header.seq, _x.plane_point.header.stamp.secs, _x.plane_point.header.stamp.nsecs,) = _struct_7d3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.plane_point.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.plane_point.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 36
      (_x.plane_point.point.x, _x.plane_point.point.y, _x.plane_point.point.z, _x.normal.header.seq, _x.normal.header.stamp.secs, _x.normal.header.stamp.nsecs,) = _struct_3d3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.normal.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.normal.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 36
      (_x.normal.vector.x, _x.normal.vector.y, _x.normal.vector.z, _x.slave_point.header.seq, _x.slave_point.header.stamp.secs, _x.slave_point.header.stamp.nsecs,) = _struct_3d3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.slave_point.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.slave_point.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 92
      (_x.slave_point.point.x, _x.slave_point.point.y, _x.slave_point.point.z, _x.top_left.x, _x.top_left.y, _x.top_left.z, _x.top_right.x, _x.top_right.y, _x.top_right.z, _x.bottom_left.x, _x.bottom_left.y, _x.bottom_left.z, _x.bottom_right.x, _x.bottom_right.y, _x.bottom_right.z, _x.result, _x.percentage_inliers, _x.percentage_disp_inliers, _x.percentage_valid_disp, _x.error,) = _struct_3d12fif2if.unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.pose.header.seq, _x.pose.header.stamp.secs, _x.pose.header.stamp.nsecs))
      _x = self.pose.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_7d3I.pack(_x.pose.pose.position.x, _x.pose.pose.position.y, _x.pose.pose.position.z, _x.pose.pose.orientation.x, _x.pose.pose.orientation.y, _x.pose.pose.orientation.z, _x.pose.pose.orientation.w, _x.plane_point.header.seq, _x.plane_point.header.stamp.secs, _x.plane_point.header.stamp.nsecs))
      _x = self.plane_point.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_3d3I.pack(_x.plane_point.point.x, _x.plane_point.point.y, _x.plane_point.point.z, _x.normal.header.seq, _x.normal.header.stamp.secs, _x.normal.header.stamp.nsecs))
      _x = self.normal.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_3d3I.pack(_x.normal.vector.x, _x.normal.vector.y, _x.normal.vector.z, _x.slave_point.header.seq, _x.slave_point.header.stamp.secs, _x.slave_point.header.stamp.nsecs))
      _x = self.slave_point.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_3d12fif2if.pack(_x.slave_point.point.x, _x.slave_point.point.y, _x.slave_point.point.z, _x.top_left.x, _x.top_left.y, _x.top_left.z, _x.top_right.x, _x.top_right.y, _x.top_right.z, _x.bottom_left.x, _x.bottom_left.y, _x.bottom_left.z, _x.bottom_right.x, _x.bottom_right.y, _x.bottom_right.z, _x.result, _x.percentage_inliers, _x.percentage_disp_inliers, _x.percentage_valid_disp, _x.error))
    except struct.error as se: self._check_types(se)
    except TypeError as te: self._check_types(te)

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.pose is None:
        self.pose = geometry_msgs.msg.PoseStamped()
      if self.plane_point is None:
        self.plane_point = geometry_msgs.msg.PointStamped()
      if self.normal is None:
        self.normal = geometry_msgs.msg.Vector3Stamped()
      if self.slave_point is None:
        self.slave_point = geometry_msgs.msg.PointStamped()
      if self.top_left is None:
        self.top_left = geometry_msgs.msg.Point32()
      if self.top_right is None:
        self.top_right = geometry_msgs.msg.Point32()
      if self.bottom_left is None:
        self.bottom_left = geometry_msgs.msg.Point32()
      if self.bottom_right is None:
        self.bottom_right = geometry_msgs.msg.Point32()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.pose.header.seq, _x.pose.header.stamp.secs, _x.pose.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.pose.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.pose.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 68
      (_x.pose.pose.position.x, _x.pose.pose.position.y, _x.pose.pose.position.z, _x.pose.pose.orientation.x, _x.pose.pose.orientation.y, _x.pose.pose.orientation.z, _x.pose.pose.orientation.w, _x.plane_point.header.seq, _x.plane_point.header.stamp.secs, _x.plane_point.header.stamp.nsecs,) = _struct_7d3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.plane_point.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.plane_point.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 36
      (_x.plane_point.point.x, _x.plane_point.point.y, _x.plane_point.point.z, _x.normal.header.seq, _x.normal.header.stamp.secs, _x.normal.header.stamp.nsecs,) = _struct_3d3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.normal.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.normal.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 36
      (_x.normal.vector.x, _x.normal.vector.y, _x.normal.vector.z, _x.slave_point.header.seq, _x.slave_point.header.stamp.secs, _x.slave_point.header.stamp.nsecs,) = _struct_3d3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.slave_point.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.slave_point.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 92
      (_x.slave_point.point.x, _x.slave_point.point.y, _x.slave_point.point.z, _x.top_left.x, _x.top_left.y, _x.top_left.z, _x.top_right.x, _x.top_right.y, _x.top_right.z, _x.bottom_left.x, _x.bottom_left.y, _x.bottom_left.z, _x.bottom_right.x, _x.bottom_right.y, _x.bottom_right.z, _x.result, _x.percentage_inliers, _x.percentage_disp_inliers, _x.percentage_valid_disp, _x.error,) = _struct_3d12fif2if.unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_3d12fif2if = struct.Struct("<3d12fif2if")
_struct_3d3I = struct.Struct("<3d3I")
_struct_3I = struct.Struct("<3I")
_struct_7d3I = struct.Struct("<7d3I")
