"""autogenerated by genpy from fast_plane_detection/SlavePoint.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import geometry_msgs.msg

class SlavePoint(genpy.Message):
  _md5sum = "97fcacf5bd73886a5a75c1efaa16ed95"
  _type = "fast_plane_detection/SlavePoint"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """# The coordinates of the 3D point around which the local plane is estimated
geometry_msgs/Point32 end_effector

# Describes the contact situation
bool  contact
================================================================================
MSG: geometry_msgs/Point32
# This contains the position of a point in free space(with 32 bits of precision).
# It is recommeded to use Point wherever possible instead of Point32.  
# 
# This recommendation is to promote interoperability.  
#
# This message is designed to take up less space when sending
# lots of points at once, as in the case of a PointCloud.  

float32 x
float32 y
float32 z
"""
  __slots__ = ['end_effector','contact']
  _slot_types = ['geometry_msgs/Point32','bool']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       end_effector,contact

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(SlavePoint, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.end_effector is None:
        self.end_effector = geometry_msgs.msg.Point32()
      if self.contact is None:
        self.contact = False
    else:
      self.end_effector = geometry_msgs.msg.Point32()
      self.contact = False

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_struct_3fB.pack(_x.end_effector.x, _x.end_effector.y, _x.end_effector.z, _x.contact))
    except struct.error as se: self._check_types(se)
    except TypeError as te: self._check_types(te)

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.end_effector is None:
        self.end_effector = geometry_msgs.msg.Point32()
      end = 0
      _x = self
      start = end
      end += 13
      (_x.end_effector.x, _x.end_effector.y, _x.end_effector.z, _x.contact,) = _struct_3fB.unpack(str[start:end])
      self.contact = bool(self.contact)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_struct_3fB.pack(_x.end_effector.x, _x.end_effector.y, _x.end_effector.z, _x.contact))
    except struct.error as se: self._check_types(se)
    except TypeError as te: self._check_types(te)

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.end_effector is None:
        self.end_effector = geometry_msgs.msg.Point32()
      end = 0
      _x = self
      start = end
      end += 13
      (_x.end_effector.x, _x.end_effector.y, _x.end_effector.z, _x.contact,) = _struct_3fB.unpack(str[start:end])
      self.contact = bool(self.contact)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_3fB = struct.Struct("<3fB")
